import Store from '../vuex/index.js'
import EventBus from "./eventBus.js"
import router from "../router"
//掉线
window.logOut = function () {
  Store.commit('setLogOut');
  EventBus.$emit("logOut");
  router.go(-(history.length-1));
}

window.refreshUserInfo = function (data) {
  console.log("refreshUserInfo" + data.nickName + "\n" + data.iconURL);
  Store.commit("setUserInfoName", {
    name: data.nickName
  });
  Store.commit("setUserInfoHeadIcon", {
    headIcon: data.iconURL
  });
}

//原生推送传递过来的消息数据：
window.receivedMessage = function (message) {
  if (typeof message === "string") {
    message=JSON.parse(message);
    if (message.type==="BT_UNBIND"){
      EventBus.$emit("deviceMoveRoom");
    }
  }
  EventBus.$emit("receivedMessage",message);
}

//原生推送传递过来的消息数据：
window.nativeMessageClickTo = function (type) {
  EventBus.$emit("nativeMessageClickTo",type);
}

window.refreshWebData = function () {
  EventBus.$emit("refreshWebData");
}

//原生绑定成功,在这里绑定familyId
window.bindFamilyId = function (data) {
  if (typeof data === "string") {
    data=JSON.parse(data)
  }
  EventBus.$emit("bindFamilyId", data.sn);
  EventBus.$emit("showCard", data.sn);
}

//蓝牙设备有变化（位置、名称、组等等等）,回调
window.onResume = function () {
  EventBus.$emit("onResume");
  EventBus.$emit("refreshMyScene");
};

window.devReport = function (msgData) {
	if (typeof msgData === "string") {
	  try {
      msgData = JSON.parse(msgData);
    } catch (e) {
	    return;
    }
  }
	//蓝牙设备删除上报,延时调刷新设备列表
	if (msgData.OpCode && msgData.OpCode == 6 && msgData.Result == 0)
	    setTimeout(() => {
			EventBus.$emit("onResume");
	    }, 700);
	 //蓝牙设备添加上报,延时调刷新设备列表
	 else if (msgData.OpCode && msgData.OpCode == 5 && msgData.Result == 0){
		setTimeout(() => {
			 EventBus.$emit("onResume");
		}, 700);
	 }
};

window.netWorkChange = function (netState) {
  if (typeof netState === "string") {
    netState=JSON.parse(netState)
  }
  EventBus.$emit("netWorkChange",netState.status);
  Store.commit('setNetState',netState.status);
}

window.receivedMqttMessage = function (msg) {
  console.log("MQTT消息:"+msg);
  EventBus.$emit("receivedMqttMessage",msg);
}
