/**
 * 使用方法：
 * 返回true，继续执行下面的逻辑，否则，提醒对应函数的返回字符串，不在执行后面的程序
 * **/

const ValidateRules = {
  // 判断只能包含数字及中英文
  checkIsChEnNum(str){
  var pattern = /^[A-Za-z0-9\u4e00-\u9fa5]+$/gi;
  if (pattern.test(str))
  return true;
  else
  return false;
  },
  /**判断是否包含特殊字符**/
  hasSpecialcode:function(str){
    var reg = new RegExp("/^[\u4e00-\u9fa5_a-zA-Z0-9]+$/",'g');
    if(str.match(reg)){
      return true;
    }
    return false;
  },
  isEmojiCharacter:function(substring){
    if(substring){
      var reg = new RegExp("[~#^$@%&!?%*]", 'g');
      if (substring.match(reg)) {
        return true;
      }
      for ( var i = 0; i < substring.length; i++) {
        var hs = substring.charCodeAt(i);
        console.log("字符的编码是---"+hs);
        if(0x2648 <= hs && hs <= 0x264F){
          return true;
        }
        if (hs == 0x20e3|| hs == 0x2b50 || hs == 0x26CE) {
          return true;
        }
        if (0xd800 <= hs && hs <= 0xdbff) {
          if (substring.length > 1) {
            var ls = substring.charCodeAt(i + 1);
            var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
            if (0x1d000 <= uc && uc <= 0x1f77f) {
              return true;
            }
          }
        } else if (substring.length > 1) {
          var ls = substring.charCodeAt(i + 1);
          if (ls == 0x20e3) {
            return true;
          }
        } else {
          if (0x2100 <= hs && hs <= 0x27ff) {
            return true;
          } else if (0x2B05 <= hs && hs <= 0x2b07) {
            return true;
          } else if (0x2934 <= hs && hs <= 0x2935) {
            return true;
          } else if (0x3297 <= hs && hs <= 0x3299) {
            return true;
          }else if (0x32650 <= hs && hs <= 0x2653) {
            return true;
          }else if(0x2648 <= hs && hs <= 0x264F){
            return true;
          }else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030
            || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b
            || hs == 0x2b50 || hs == 0x26CE) {
            return true;
          }
        }
      }
    }
    return false;
  }, /**校验设备重命名
   * 校验规则：
   * 设备标题最多显示8个字，超过8个字，用...表示，不允许换行；
   * 命名规则：设备标题支持英文，中文，数字，不支持特殊符号和表情符；
   * **/
  Validate_deviceName:function(devicename, oldname){
    if(devicename=='' || devicename == undefined || devicename == null){
      return '请输入设备名称';
    }else if(devicename == oldname){
      return '请输入一个新名称';
    }else if(devicename.length>12){
      return '请输入12个以内的字符';
    }else if(!this.checkIsChEnNum(devicename)){
      return '名称只支持中英文及数字';
    }
    return true;
  },
  /**校验新建房间
   * 校验规则：
   * 房间名称最多支持输入12个字，房间总个数不可以超过30个；
   * 房间名称输入规则：不允许重复(云端校验);支持英文，中文，数字，不支持特殊符号和表情符；
   * **/
  Validate_roomname:function(roomname,currentroomnum){
    if(roomname=='' || roomname == undefined || roomname == null){
      return '请输入房间名称';
    }else if(currentroomnum>=31){
      return '最多允许创建30个房间';
    }else if(roomname.length>12){
      return '请输入12个以内的字符';
    }else if(!this.checkIsChEnNum(roomname)){
      return '名称只支持中英文及数字';
    }
    return true;
  },
  /**校验开关按键重命名
   * 校验规则：
   * 开关名称最多支持输入6个字;
   * 开关名称输入规则：允许重复;支持英文，中文，数字，不支持特殊符号和表情符;
   * **/
  Validate_keyname:function(keyname){
    if(keyname=='' || keyname == undefined || keyname == null){
      return '请输入开关名称';
    }else if(keyname.length>6){
      return '请输入6个以内的字符';
    }else if(!this.checkIsChEnNum(keyname)){
      return '名称只支持中英文及数字';
    }
    return true;
  }
}

export default ValidateRules


