
export function commonSendOrder(sn, command) {
  let orderMain = {
    "action": "INVOKE_SDK_FUNCTION",
    "functions": [{
      "ParameterList": [{
        "type": "STRING",
        "value": ""
      }, {
        "type": "STRING",
        "value": ""
      }],
      "name": "sendAsyncRawCommand"
    }]
  };
  orderMain.functions[0].ParameterList[1].value = sn;
  orderMain.functions[0].ParameterList[0].value = command;
  return orderMain;
}

export function sendOrder(orderName, value) {
  let orderMain = {
    "action": "INVOKE_SDK_FUNCTION",
    "functions": [{
      "ParameterList": [{
        "type": "STRING",
        "value": ""
      }, {
        "type": "STRING",
        "value": ""
      }],
      "name": "sendAsyncRawCommand"
    }]
  };
  let order = {
    api_version: '0.1',
    from: '',
    to: '',
    msg_id: 'xfBai-127',
    msg_class: 'control_mgmt',
    msg_name: orderName,
    msg_type: 'set',
    token: '',
  };

  if (orderName === 'device_control') {
    order.device = {
      device_id: parseInt(Store.state.dataFromNative.macAddr),
      device_status: {
        state: value,
      },
    };
  }
  else if (orderName === 'device_state_get') {
    order.msg_type = 'get';
    order.device_list = [{device_id: parseInt(Store.state.dataFromNative.macAddr)}];
  }
  else if (orderName === 'device_del') {
    order.msg_class = 'device_mgmt';
    order.device_list = [{device_id: parseInt(Store.state.dataFromNative.macAddr)}];
  }

  orderMain.functions[0].ParameterList[1].value = Store.state.dataFromNative.sn;
  orderMain.functions[0].ParameterList[0].value = '@#$%' + getLength(JSON.stringify(order)) + JSON.stringify(order);
  return orderMain;
}

function getLength(str) {
  let charLen = str.replace(/[^\u0000-\u00ff]/g, "aa").length + 8; //把中文字符替换成2个英文字母，再计算字节长度
  let hexStr = charLen.toString(16);
  let hexLen = charLen.toString(16).length;
  if (hexLen < 4) { // 补全len位
    for (let i = 0; i < 4 - hexLen; i++) {
      hexStr = '0' + hexStr;
    }
  }
  return hexStr;
}